=== 3rdparty/clipper/CMakeLists.txt ===
project(${CLIPPER_LIBRARY})

set(CLIPPER_MAJOR_VERSION 6 PARENT_SCOPE)
set(CLIPPER_MINOR_VERSION 4 PARENT_SCOPE)
set(CLIPPER_PATCH_VERSION 2 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB lib_srcs *.cpp)
file(GLOB lib_hdrs *.hpp)

add_library(${CLIPPER_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  endif()
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${CLIPPER_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${CLIPPER_LIBRARY}
  PROPERTIES OUTPUT_NAME ${CLIPPER_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${CLIPPER_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${CLIPPER_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${CLIPPER_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

vp_set_source_file_compile_flag(clipper.cpp -Wno-float-equal -Wno-class-memaccess)
