=== debian/changelog ===
visp (3.5.0-4) unstable; urgency=medium

  [ root ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Submit, Repository.

  [ Fabien Spindler ]
  * Remove remaining ogre dep (see previous commit that was incomplete)

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Tue, 30 Aug 2022 16:56:40 +0200

visp (3.5.0-3) unstable; urgency=medium

  * Remove ogre dep that is blocking migration
  * Update outdated Standards Version

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Fri, 08 Jul 2022 14:55:15 +0200

visp (3.5.0-2) unstable; urgency=medium

  * source only upload

 -- Olivier Sallou <osallou@debian.org>  Thu, 24 Feb 2022 09:54:08 +0000

visp (3.5.0-1) unstable; urgency=medium

  * Remove 3.4.0 patches
  * New upstream version 3.5.0
  * Update debian material for visp 3.5.0

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Tue, 15 Feb 2022 14:42:28 +0100

visp (3.4.0-6) unstable; urgency=medium

  * Source only upload

 -- Olivier Sallou <osallou@debian.org>  Thu, 20 Jan 2022 08:21:16 +0000

visp (3.4.0-5) unstable; urgency=medium

  * Update to catch2 2.13.7. (Closes: #1001299)

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Wed, 15 Dec 2021 17:05:16 +0100
